/*  Project bardemo
    Bernd Herd Software Entwicklung
    Copyright  1995. All Rights Reserved.

    SUBSYSTEM:    bardemo.exe Application
    FILE:         bardmapp.cpp
    AUTHOR:       Bernd Herd


    OVERVIEW
    ========
    Source file for implementation of bardemoApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "bardmapp.h"
#include "brdmmdic.h"
#include "brdmmdi1.h"
#include "brdmolvw.h"
#include "brdmabtd.h"                        // Definition of about dialog.       


//{{bardemoApp Implementation}}


//
// OLE's ITypeInfo browses this symbol table for a list of all data,
// properties, and methods exposed by this automated class.
//
DEFINE_AUTOAGGREGATE(bardemoApp, OcApp->Aggregate)
    EXPOSE_APPLICATION(bardemoApp, "Application", "Application object", 0)
    EXPOSE_QUIT("Quit", "Quit application", 0)
//{{bardemoAppSYM_TBL_BEGIN}}
//{{bardemoAppSYM_TBL_END}}
END_AUTOAGGREGATE(bardemoApp, tfAppObject | tfCanCreate, "bardemoApp", 0, 0);


DEFINE_APP_DICTIONARY(AppDictionary);

static TPointer<TOcRegistrar> Registrar;

REGISTRATION_FORMAT_BUFFER(100)

BEGIN_REGISTRATION(ApplicationReg)
    REGDATA(clsid, "{5DB66880-5D84-101C-A335-0080AD08504C}")
    REGDATA(appname, "bardemo Server")
    REGDATA(description, "bardemo Server Application")
    REGDATA(progid, "bardemo.Application.1")
    REGDATA(cmdline, "/Automation")
    REGDATA(usage, ocrMultipleUse)
//    REGDATA(debugger, "TDW")
END_REGISTRATION

//{{DOC_VIEW}}
 DEFINE_DOC_TEMPLATE_CLASS(bardemoOleDocument, bardemoOleView, DocType1);
// DEFINE_DOC_TEMPLATE_CLASS(TOleDocument, bardemoOleView, DocType1);
//{{DOC_VIEW_END}}

//{{DOC_MANAGER}}
BEGIN_REGISTRATION(__dvReg1)
/*    REGDATA(progid, "bardemo.Document.1")
    REGDATA(description, "bardemo Document Version 1") */
    REGDATA(progid, "BarVision.Document.1")
    REGDATA(description, "BarVision Document Version 1")
    REGDATA(extension, "OLB")
    REGDATA(docfilter, "*.OLB")
    REGDOCFLAGS(dtAutoDelete | dtUpdateDir | dtAutoOpen | dtRegisterExt)
//    REGDATA(debugger, "TDW")
    REGDATA(menuname, "bardemoOleView")
    REGDATA(insertable, "")
    REGDATA(verb0, "&Edit")
    REGDATA(verb1, "&Open")
    REGFORMAT(0, BarVisionFormat,   ocrContent,  ocrHGlobal, ocrGetSet)
    REGFORMAT(1, ocrEmbedSource,  ocrContent,  ocrIStorage, ocrGet)
    REGFORMAT(2, ocrMetafilePict, ocrContent,  ocrMfPict | ocrStaticMed, ocrGetSet)
    REGFORMAT(3, ocrBitmap, ocrContent,  ocrGDI | ocrStaticMed, ocrGet)
    REGFORMAT(4, ocrDib, ocrContent,  ocrHGlobal | ocrStaticMed, ocrGet)
    REGFORMAT(5, ocrLinkSource, ocrContent,  ocrIStream, ocrGet)
END_REGISTRATION
DocType1 __dvt1(__dvReg1);
//{{DOC_MANAGER_END}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(bardemoApp, TApplication)
//{{bardemoAppRSP_TBL_BEGIN}}
    EV_OWLVIEW(dnCreate, EvNewView),
    EV_OWLVIEW(dnClose,  EvCloseView),
    EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
    EV_WM_WININICHANGE,
//{{bardemoAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//////////////////////////////////////////////////////////
// bardemoApp
// =====
//
bardemoApp::bardemoApp () : TApplication(::ApplicationReg["appname"], ::Module, &::AppDictionary)
{
    Printer = 0;
    Printing = 0;
    ToolBar    = NULL;
    TypeStatic = NULL;

    SetDocManager(new TDocManager(dmMDI, this));

    // INSERT>> Your constructor code here.
}


bardemoApp::~bardemoApp ()
{
    if (Printer)
	delete Printer;

    // INSERT>> Your destructor code here.
}


void bardemoApp::CreateGadgets (TControlBar *cb, bool server)
{   TypeStatic = new TStatic((TWindow *) cb, IDS_TYPESTATIC, "", 0, 0, 50, 20 );

    // --------- Save Toolbar Access Pointer for later ------
    ToolBar = cb;

    if (!server) {
	cb->Insert(*new TButtonGadget(CM_MDIFILENEW, CM_MDIFILENEW));
	cb->Insert(*new TButtonGadget(CM_MDIFILEOPEN, CM_MDIFILEOPEN));
	cb->Insert(*new TButtonGadget(CM_FILESAVE, CM_FILESAVE));
	cb->Insert(*new TSeparatorGadget(6));
    }

    cb->Insert(*new TButtonGadget(CM_EDITCUT, CM_EDITCUT));
    cb->Insert(*new TButtonGadget(CM_EDITCOPY, CM_EDITCOPY));
    cb->Insert(*new TButtonGadget(CM_EDITPASTE, CM_EDITPASTE));
    cb->Insert(*new TSeparatorGadget(6));
    cb->Insert(*new TButtonGadget(CM_EDITUNDO, CM_EDITUNDO));
    cb->Insert(*new TSeparatorGadget(6));
    cb->Insert(*new TButtonGadget(CM_EDITFIND, CM_EDITFIND));
    cb->Insert(*new TButtonGadget(CM_EDITFINDNEXT, CM_EDITFINDNEXT));

    if (!server) {
	cb->Insert(*new TSeparatorGadget(6));
	cb->Insert(*new TButtonGadget(CM_FILEPRINT, CM_FILEPRINT));
	cb->Insert(*new TButtonGadget(CM_FILEPRINTPREVIEW, CM_FILEPRINTPREVIEW));
    }

    cb->Insert(*new TSeparatorGadget(6));
    cb->Insert(*new TControlGadget(*TypeStatic, TControlGadget::Recessed) );

    // Add fly-over help hints.
    cb->SetHintMode(TGadgetWindow::EnterHints);
}


void bardemoApp::SetupSpeedBar (TOleMDIFrame *frame)
{
    //
    // Create default toolbar New and associate toolbar buttons with commands.
    //
    TControlBar* cb = new TControlBar(frame);
    CreateGadgets(cb);

    // Setup the toolbar ID used by OLE 2 for toolbar negotiation.
    cb->Attr.Id = IDW_TOOLBAR;

    frame->Insert(*cb, TDecoratedFrame::Top);
}


//////////////////////////////////////////////////////////
// bardemoApp
// =====
// Application intialization.
//
void bardemoApp::InitMainWindow ()
{
    if (nCmdShow != SW_HIDE)
        nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

    mdiClient = new bardemoMDIClient(this);
    TOleMDIFrame* frame = new TOleMDIFrame(Name, MDI_MENU, *mdiClient, true, this);

    //
    // Assign ICON w/ this application.
    //
    frame->SetIcon(this, IDI_MDIAPPLICATION);

    //
    // Menu associated with window and accelerator table associated with table.
    //
    frame->AssignMenu(MDI_MENU);
    
    //
    // Associate with the accelerator table.
    //
    frame->Attr.AccelTable = MDI_MENU;

    SetupSpeedBar(frame);

    TStatusBar *sb = new TStatusBar(frame, TGadget::Recessed,
                                    TStatusBar::CapsLock        |
                                    TStatusBar::NumLock         |
                                    TStatusBar::ScrollLock      |
                                    TStatusBar::Overtype);
    frame->Insert(*sb, TDecoratedFrame::Bottom);
  
    SetMainWindow(frame);

    frame->SetMenuDescr(TMenuDescr(MDI_MENU));

    //
    // Windows 3-D controls.
    //
//    EnableCtl3d(true);
}


//////////////////////////////////////////////////////////
// bardemoApp
// =====
// Response Table handlers:
//
void bardemoApp::EvNewView (TView& view)
{
    TOleView* ov = TYPESAFE_DOWNCAST(&view, TOleView);
    // If  we're embedded and we're opening out of place then don't create the child window.
    if (view.GetDocument().IsEmbedded() && ov && !ov->IsOpenEditing()) {
        TWindow* vw = view.GetWindow();
        vw->SetParent(TYPESAFE_DOWNCAST(GetMainWindow(), TOleFrame)->GetRemViewBucket());
        vw->Create();
    } else {
        TMDIClient *mdiClient = TYPESAFE_DOWNCAST(GetMainWindow()->GetClientWindow(), TMDIClient);
        if (mdiClient) {
            bardemoMDIChild* child = new bardemoMDIChild(*mdiClient, 0, 0);

            // Associate ICON w/ this child window.
            child->SetIcon(this, IDI_DOC);

            if (view.GetViewMenu())
	            child->SetMenuDescr(*view.GetViewMenu());

            child->Create();
            child->SetClientWindow(view.GetWindow());
        }
    }

    if (!ov || !ov->GetOcRemView())
        OcApp->SetOption(amEmbedding, false);
}


void bardemoApp::EvCloseView (TView&)
{
}


//////////////////////////////////////////////////////////
// bardemoApp
// ===========
// Menu Help About bardemo.exe command
void bardemoApp::CmHelpAbout ()
{
    //
    // Show the modal dialog.
    //
    bardemoAboutDlg(&TWindow(::GetFocus(), this)).Execute();
}


void bardemoApp::EvWinIniChange (char far* section)
{
    if (strcmp(section, "windows") == 0) {
        // If the device changed in the WIN.INI file then the printer
        // might have changed.  If we have a TPrinter (Printer) then
        // check and make sure it's identical to the current device
        // entry in WIN.INI.
        if (Printer) {
            char printDBuffer[255];
            LPSTR printDevice = printDBuffer;
            LPSTR devName;
            LPSTR driverName = 0;
            LPSTR outputName = 0;
        
            if (::GetProfileString("windows", "device", "", printDevice, sizeof(printDevice))) {
                // The string which should come back is something like:
                //
                //      HP LaserJet III,hppcl5a,LPT1:
                //
                // Where the format is:
                //
                //      devName,driverName,outputName
                //
                devName = printDevice;
                while (*printDevice) {
                    if (*printDevice == ',') {
                        *printDevice++ = 0;
                        if (!driverName)
                            driverName = printDevice;
                        else
                            outputName = printDevice;
                    } else
                        printDevice = ::AnsiNext(printDevice);
                }

                if ((Printer->GetSetup().Error != 0)                                ||
                    (strcmp(devName, Printer->GetSetup().GetDeviceName()) != 0)    ||
                    (strcmp(driverName, Printer->GetSetup().GetDriverName()) != 0) ||
                    (strcmp(outputName, Printer->GetSetup().GetOutputName()) != 0)) {
                
                    // New printer installed so get the new printer device now.
                    delete Printer;
                    Printer = new TPrinter(this);
                }
            } else {
                // No printer installed (GetProfileString failed).
                delete Printer;
                Printer = new TPrinter(this);
            }
        }
    }
}


int OwlMain (int , char* [])
{
    try {
        ::Registrar = new TOcRegistrar(::ApplicationReg, TOleDocViewAutoFactory<bardemoApp>(), TApplication::GetCmdLine(), ::DocTemplateStaticHead);
        if (::Registrar->IsOptionSet(amAnyRegOption))
            return 0;

        // If this is an exe server normal run, run the app now. Otherwise, wait
        // until our factory gets a call.
        return ::Registrar->Run();
    }
    catch (xmsg& x) {
        ::MessageBox(0, x.why().c_str(), "Exception", MB_OK);
    }

    return -1;
}
