#if !defined(__bardmapp_h)              // Sentry, use file only if it's not already included.
#define __bardmapp_h

/*  Project bardemo
    Bernd Herd Software Entwicklung
    Copyright  1995. All Rights Reserved.

    SUBSYSTEM:    bardemo.exe Application
    FILE:         bardmapp.h
    AUTHOR:       Bernd Herd


    OVERVIEW
    ========
    Class definition for bardemoApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <ocf\automacr.h>

#include "brdmmdic.h"

#include "bardmapp.rh"            // Definition of all resources.


//{{TApplication = bardemoApp}}
class bardemoApp : public TApplication, public TOcModule {
private:
    void SetupSpeedBar (TOleMDIFrame *frame);
    TControlBar *ToolBar;
    TStatic     *TypeStatic;

public:
    bardemoApp ();
    virtual ~bardemoApp ();

    void CreateGadgets (TControlBar *cb, bool server = false);
    TControlBar *GetToolBar()    { return ToolBar; };
    TStatic     *GetTypeStatic() { return TypeStatic; };

    bardemoMDIClient  *mdiClient;

    // Public data members used by the print menu commands and Paint routine in MDIChild.
    TPrinter        *Printer;                           // Printer support.
    int             Printing;                           // Printing in progress.

//{{bardemoAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow ();
//{{bardemoAppVIRTUAL_END}}

//{{bardemoAppRSP_TBL_BEGIN}}
protected:
    void EvNewView (TView& view);
    void EvCloseView (TView& view);
    void CmHelpAbout ();
    void EvWinIniChange (char far* section);
//{{bardemoAppRSP_TBL_END}}

DECLARE_AUTOAGGREGATE(bardemoApp)
AUTODETACH
//{{bardemoAppAUTO_TBL_BEGIN}}
//{{bardemoAppAUTO_TBL_END}}

DECLARE_RESPONSE_TABLE(bardemoApp);
};    //{{bardemoApp}}


#endif                                      // __bardmapp_h sentry.
