#if !defined(__brdmolvw_h)              // Sentry, use file only if it's not already included.
#define __brdmolvw_h

/*  Project bardemo
    Bernd Herd Software Entwicklung
    Copyright  1995. All Rights Reserved.

    SUBSYSTEM:    bardemo.exe Application
    FILE:         brdmolvw.h
    AUTHOR:       Bernd Herd


    OVERVIEW
    ========
    Class definition for bardemoOleView (TOleView).      
*/


#include <owl\owlpch.h>
#pragma hdrstop


#include "bardmapp.rh"            // Definition of all resources.

#include "barvis.h"		  // Barcode-Support


const char  BarVisionFormat[] = "BarVision";

// -------------- Dokument-Klasse ------------------------
class _USERCLASS bardemoOleDocument : public TOleDocument {

public:
    enum {
      PrevProperty = TOleDocument::NextProperty-1,
      BarCode,
      CodeTypes,
      NextProperty,
    };

    bardemoOleDocument(TDocument* parent = 0);
   ~bardemoOleDocument();

    // implement virtual methods of TDocument
    bool   Open(int mode, const char far* path=0);
    bool   Close();
    bool   Commit(bool force = false);

    int         FindProperty(const char far* name);  // return index
    int         PropertyFlags(int index);
    const char* PropertyName(int index);
    int         PropertyCount()
    {
      return NextProperty - 1;
    }

    int         GetProperty(int index, void far* dest, int textlen=0);

    string GetCodeString(void);
    void   SetCodeString(string);
    ECODE  GetCodeTypes(void);
    void   SetCodeTypes(ECODE);

protected:

    string BarCodeString;
    ECODE  BarCodeTypes;


};	// bardemoOleDocument


// TMyEdit -----------------------------------------------
// Edit-Element nur Grobuchstaben und so
class TMyEdit : public TEdit {
public:
   TMyEdit(TWindow* parent, int Id, const char far *text, int x, int y, int w, int h,
	 uint textLen = 0, bool multiline =false, TModule* module = 0);
};



// -------------- View-Klasse ----------------------------
//{{TOleView = bardemoOleView}}
class bardemoOleView : public TOleView {
public:
    bardemoOleView (bardemoOleDocument& doc, TWindow* parent = 0);
    virtual ~bardemoOleView ();

private:
    TControlBar *ToolBar;
    TMyEdit     *MyEdit;
    int		 EditHeight;		// Y-Height for Edit-Control

    bardemoOleDocument &BarDocument;

//{{bardemoOleViewVIRTUAL_BEGIN}}
public:
    virtual void Paint (TDC& dc, bool erase, TRect& rect);
    virtual char far* GetClassName() { return "bardemoOleView";};
    virtual void GetWindowClass(WNDCLASS far& wndclass);
//{{bardemoOleViewVIRTUAL_END}}
//{{bardemoOleViewRSP_TBL_BEGIN}}
protected:
    void EvGetMinMaxInfo (MINMAXINFO far& minmaxinfo);
    bool EvOcViewShowTools (TOcToolBarInfo far& tbi);
    void EvSize(uint sizeType, TSize& size);
    void EvEnChange();
    void EvActivate(uint active, bool minimized, HWND hWndOther);
    void EvSetFocus(HWND hWndLostFocus);
    bool EvOcViewClipData(TOcFormatData far& format);
    bool EvOcViewPartSize(TOcPartSize far& ps);

//{{bardemoOleViewRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(bardemoOleView);
};    //{{bardemoOleView}}


#endif                                      // __brdmolvw_h sentry.
