{* S I M P L E . P A S
 *
 * Einfaches Borland Pascal 7.0 - Demo fr BarVision
 *
 *
 *	Dipl. Ing. Bernd Herd                    Dipl. Ing Harald Nuding
 *	Heidelberger Landstr. 316		 Niederstrae.
 *	64297 Darmstadt-Eberstadt                Darmstadt
 *	Tel. und Fax: 06151 / 59 12 16
}


program Simple;

{$R Simple.RES}       { Kann mit "BRC -R IDEPDEMO" bersetzt werden, anschlieend ins Root-Verzeichnis kopieren }

uses WinTypes, WinProcs, OWindows, oDialogs, Strings, oStdDlgs,
     SimpleR,             { Ressourcen-IDs }
     BarVis;              { Unit zur Verwndung der BARVIS.DLL }

const
  bsa_Name =  'Simple';

type

{ TBitSimpleApp, a TApplication descendant }

  TBitSimpleApp = object(TApplication)
    procedure InitMainWindow; virtual;
  end;

{ TSimpleWindow, a TWindow descendant }

  PSimpleWindow = ^TSimpleWindow;
  TSimpleWindow = object(TWindow)
    BarCodeString : Array[0..20] of Char;

    constructor Init(ATitle: PChar);
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure CMAbout(var Msg: TMessage);      virtual cm_First + cm_About;
    procedure CMExitSimple(var Msg: TMessage); virtual cm_First + cm_Exit;
    procedure CMInputCode(var Msg: TMessage); virtual cm_First + cm_InputCode;
    procedure CMCopy     (var Msg: TMessage); virtual cm_First + cm_Copy;
  end;


{ Construct the TBitSimpleApp's MainWindow of type TSimpleWindow }

procedure TBitSimpleApp.InitMainWindow;
begin
  MainWindow := New(PSimpleWindow, Init(bsa_name));
end;

{ Constructor for a TSimpleWindow, Sets our Window }
constructor TSimpleWindow.Init(ATitle: PChar);
begin
  TWindow.Init(nil, ATitle);
  Attr.Menu := LoadMenu(HInstance, 'SIMPLEMENU');
  strcopy(BarCodeString, '012345678912');
end;




{ Responds to an incoming "paint" message by redrawing the BarCode. }

procedure TSimpleWindow.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var rc : TRect;
begin
   GetClientRect(HWindow, rc);
   Bar2Hdc(PaintDC,                             {  Ausgabe-Device-Kontext }
           BarCodeString,                       {  Auszugebende BarCode-Nummer }
           @rc,                                 {  Koordinaten }
           NIL,                                 {  Keine Schriftart vorgeben }
           BT_NOADDON);                         {  Alle Code-Arten ausser ADDON-Codes }
end;


{ Info-Dialogbox anzeigen }
procedure TSimpleWindow.CMAbout(var Msg : TMessage);
Begin
  Application^.ExecDialog(new(PDialog, Init(@self, 'ABOUTBOX')));
End;

{ Programm beenden }
procedure TSimpleWindow.CMExitSimple(var Msg : TMessage);
Begin
  CloseWindow;
End;


{ Strichcode in Zwischenablage kopieren }
procedure TSimpleWindow.CMCopy(var Msg : TMessage);
Begin
   BarToClipboard(
           BarCodeString,                       {  Auszugebende BarCode-Nummer }
           NIL,                                 {  Keine Schriftartangabe }
           5000,3000,                           {  Gre 5 x 3 cm }
           BT_NOADDON);                         {  Alle Code-Arten ausser ADDON-Codes }
End;



{ Strichcode ndern }
procedure TSimpleWindow.CMInputCode(var Msg : TMessage);
Begin
  Application^.ExecDialog(new(PInputDialog, Init(@self,
                                                 'Strichcode ndern',
                                                 'Neuer Strichcode',
                                                 BarCodeString,
                                                 20
                                                 )));
  InvalidateRect(HWindow, NIL, TRUE);
End;



{ Declare a variable of type TBitSimpleApp }

var
  SimpleApp: TBitSimpleApp;

{ Run the BitSimpleApp }

begin
  SimpleApp.Init(bsa_Name);
  SimpleApp.Run;
  SimpleApp.Done;
end.

